# Copyright (c) 1999-2001 by Open Source Telecom Corporation.
# Verbatim copying and distribution of this entire file is permitted
# in any medium, provided this notice is preserved.

Summary: "Common C++" - A GNU package for creating portable C++ programs
Name: CommonC++
Version: 1.6.4
Release: 5
Group: Development/Libraries
URL: http://www.voxilla.org/projects/projape.html
Source: ftp://www.voxilla.org/pub/ape/CommonC++-%{PACKAGE_VERSION}.tar.gz
Prefix: %{_prefix}
Obsoletes: APE
Copyright: GPL
BuildRoot: %{_tmppath}/CCXX-root
Packager: David Sugar <dyfet@ostel.com>

%description
Common C++ is a GNU package which offers portable "abstraction" of system
services such as threads, networks, and sockets.  Common C++ also offers
individual frameworks generally useful to developing portable C++
applications including a object persistance engine, math libraries,
threading, sockets, etc.  Common C++ is small, and highly portable.
Common C++ will support most Unix operating systems as well
as Win32, in addition to GNU/Linux.

%prep
rm -rf $RPM_BUILD_ROOT

%setup
CXXFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{_prefix}

%build
uname -a|grep SMP && make -j 2 || make

%install
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man3
make prefix=$RPM_BUILD_ROOT/%{_prefix} \
	mandir=$RPM_BUILD_ROOT/%{_mandir} install
make prefix=$RPM_BUILD_ROOT/%{_prefix} \
	mandir=$RPM_BUILD_ROOT/%{_mandir} man
strip $RPM_BUILD_ROOT/%{_prefix}/lib/libcc*.so.*

%files
%defattr(-,root,root,0755)
%doc AUTHORS COPYING COPYING.addendum NEWS README TODO OVERVIEW.TXT ChangeLog doc/html
%{_prefix}/lib/libcc*
%{_prefix}/include/cc++
%{_prefix}/bin/ccgnu-config
%{_mandir}/man3/*.3cc*
%{_datadir}/aclocal/ost_check.m4

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

