dnl Copyright (C) 2000-2001 Open Source Telecom Corporation.
dnl  
dnl This program is free software; you can redistribute it and/or modify
dnl it under the terms of the GNU General Public License as published by
dnl the Free Software Foundation; either version 2 of the License, or
dnl (at your option) any later version.
dnl 
dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl GNU General Public License for more details.
dnl 
dnl You should have received a copy of the GNU General Public License
dnl along with this program; if not, write to the Free Software 
dnl Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
dnl 
dnl As a special exception to the GNU General Public License, if you 
dnl distribute this file as part of a program that contains a configuration 
dnl script generated by Autoconf, you may include it under the same 
dnl distribution terms that you use for the rest of that program.

dnl OST_CCXX_VERSION([MINIMUM-VERSION[,ACTION-IF-FOUND[,ACTION-IF-NOT-FOUND]]])
dnl Test for usable version of CommonC++

AC_DEFUN(OST_CCXX_VERSION,
[
  AC_PATH_PROG(CCGNU_CONFIG, ccgnu-config, no)
  ccgnu_version=ifelse([$1], ,1.3.3,$1)
  AC_MSG_CHECKING(for CommonC++ version >= $ccgnu_version)
  if test "$CCGNU_CONFIG" = "no" ; then
    AC_MSG_RESULT(not found)
    echo "*** The ccgnu-config script installed by CommonC++ 1.3.0"
    echo "*** or later could not be found."
    ifelse([$3], , :, [$3])
    exit -1
  else
    config_version=`$CCGNU_CONFIG --version`
    ccgnu_config_major_version=`echo $config_version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
    ccgnu_config_minor_version=`echo $config_version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\2/'`
    ccgnu_config_micro_version=`echo $config_version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\3/'`
           
    ccgnu_check_major_version=`echo "$ccgnu_version" | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
    ccgnu_check_minor_version=`echo "$ccgnu_version" | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\2/'`
    ccgnu_check_micro_version=`echo "$ccgnu_version" | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\3/'`
       
    version_ok=no       
    if test $ccgnu_config_major_version -gt $ccgnu_check_major_version ; then
	version_ok=yes
    elif test $ccgnu_config_major_version -eq $ccgnu_check_major_version  \
       && test $ccgnu_config_minor_version -gt $ccgnu_check_minor_version ; then
	version_ok=yes
    elif test $ccgnu_config_major_version -eq $ccgnu_check_major_version \
       && test $ccgnu_config_minor_version -eq $ccgnu_check_minor_version \
       && test $ccgnu_config_micro_version -ge $ccgnu_check_micro_version; then
       
       version_ok=yes
    fi
  
    if test "$version_ok" = "no"; then
      AC_MSG_RESULT(no)
      ost_cv_ccxx_config=false
      echo "*** An old version of CommonC++ of $config_version was found."
      echo "*** You need a version of CommonC++ newer than $ccgnu_version. The latest version of"
      echo "*** CommonC++ is always available from ftp://ftp.gnu.org/gnu/commonc++/."
      ifelse([$3], , :, [$3])
    else
      AC_MSG_RESULT(yes)
      ost_cv_ccxx_config=true
      SINGLE_FLAGS="$CXXFLAGS"
      SINGLE_LIBS="$LIBS"
      AC_SUBST(SINGLE_LIBS)
      AC_SUBST(SINGLE_FLAGS)
      CXXFLAGS="$CXXFLAGS "`$CCGNU_CONFIG --flags`
      LIBS="$LIBS "`$CCGNU_CONFIG --stdlibs`
    fi
  fi
])

AC_DEFUN(OST_CCXX_HEADER,[
	AC_DEFINE(__CCXX_CONFIG_H__)
])

AC_DEFUN(OST_CCXX_SCRIPT,[
	LIBS="-lccscript $LIBS"
])

AC_DEFUN(OST_CCXX_FOX,[
	ost_cv_lib_fox=false
	AC_CHECK_HEADERS(fox/fx.h,[
		AC_DEFINE(HAVE_FOX_FX_H)
		ost_cv_lib_fox=true])
])

AC_DEFUN(OST_CCXX_HOARD,[
	AC_ARG_ENABLE(hoard, [--disable-hoard         Disable hoard support])
	AC_ARG_ENABLE(mpatrol, [--enable-mpatrol        Enable mpatrol debugging])
	if test "$enable_mpatrol" = "yes" ; then
		LIBS="$LIBS -lmpatrolmt -lbfd -liberty"
	elif test "$enable_hoard" != "no" ; then
        	AC_CHECK_LIB(hoard, free, [LIBS="$LIBS -lhoard"])
	fi
])

AC_DEFUN(OST_CCXX_AUDIO,[
	LIBS="$LIBS -lccaudio"
])

dnl ACCONFIG TEMPLATE
dnl #undef __CCXX_CONFIG_H__
dnl #undef HAVE_FOX_FX_H
dnl END ACCONFIG
